#ifndef DPCLASS_H
#define DPCLASS_H
#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <cassert>
#include <string>
#include <stdint.h>
#include <map>
#include <vector>
#include <random>
#include <sstream>
#include <bits/stdc++.h>
#include "sseMat.h"
#include "sseAlignment.h"
#include "dirManager.h"
#include "util.h"
#include "aaAlphabet.h"
#include "threeStateDP.h"
using namespace std;

double computeTotalProbOfAlignment(int n, SSEAlign& algnobj, Submat& ssemat, DirManager& dirm);
pair<double, int> searchForTotalProb(SSEAlign& algn, int& inferredN, Submat& ssemat, int);
vector<SSEAlign> parseAlignmentData(const string&, AAAlphabet&);
int inferTime(SSEAlign&, Submat&, int);
double computeAlignmentCost(int, SSEAlign&, Submat&);
vector<vector<SSEAlign>> parseBinnedAlignmentData(const string&, AAAlphabet&, int);

#endif
