#ifndef UTILCLASS_H
#define UTILCLASS_H
#include <bits/stdc++.h>
#include <gsl/gsl_sf.h>

using namespace std;

const string alphabet = "ACDEFGHIKLMNPQRSTVWY";
const vector<int> alphMap = {0,-1,1,2,3,4,5,6,7,-1,8,9,10,11,-1,12,13,14,15,16,-1,17,18,-1,19,-1};

const int lowerBound = 5;

const int bnbConst = 1;     // accumulated length constraint of null test 

struct Cost{
   char model;
   double statementCost;
};

string num2str(const double, unsigned int, unsigned int);
int catalan(int n);
double encodeWTBits(int n);
double encodeWTNits(int n);
double encodeNats(int n);
double encodeLogStarBits(size_t n);
double encodeLogStarNits(size_t n);
double nits2bits(double x);
double bits2nits(double x);
vector<vector<double>> matrixMultiply(vector<vector<double>> A, vector<vector<double>> B);
vector<vector<double> > matrixMultiply(vector<vector<double> > A, int lambda);
void printFSAstr2Algn(const string &fsastr, const string &S, const string &T);
vector<string> fsastr2Algn(const string &fsastr, const string &S, const string &T);
string algn2Fsastr(const vector<string> &algn);
string reverse(string r);
int alph2aa(char key);
string removeNonStandardAA(string s);
vector<string> file_read(const string& f_name);
const string currentDateTime();
string getFilenameFromPath(string fn);

double polygamma(int degree, double value);
double lattice_constant(int k);
void file_append(const string& f_name, const string& content);
const string currentDateTime();
const string currentDate();
#endif